/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: RCSL 1.0/RPSL 1.0 
 *  
 * Portions Copyright (c) 1995-2002 RealNetworks, Inc. All Rights Reserved. 
 *      
 * The contents of this file, and the files included with this file, are 
 * subject to the current version of the RealNetworks Public Source License 
 * Version 1.0 (the "RPSL") available at 
 * http://www.helixcommunity.org/content/rpsl unless you have licensed 
 * the file under the RealNetworks Community Source License Version 1.0 
 * (the "RCSL") available at http://www.helixcommunity.org/content/rcsl, 
 * in which case the RCSL will apply. You may also obtain the license terms 
 * directly from RealNetworks.  You may not use this file except in 
 * compliance with the RPSL or, if you have a valid RCSL with RealNetworks 
 * applicable to this file, the RCSL.  Please see the applicable RPSL or 
 * RCSL for the rights, obligations and limitations governing use of the 
 * contents of the file.  
 *  
 * This file is part of the Helix DNA Technology. RealNetworks is the 
 * developer of the Original Code and owns the copyrights in the portions 
 * it created. 
 *  
 * This file, and the files included with this file, is distributed and made 
 * available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS ALL SUCH WARRANTIES, 
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS 
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. 
 * 
 * Technology Compatibility Kit Test Suite(s) Location: 
 *    http://www.helixcommunity.org/content/tck 
 * 
 * Contributor(s): 
 *  
 * ***** END LICENSE BLOCK ***** */ 
#ifndef CHXKEEPALIVE_H
#define CHXKEEPALIVE_H

#include "hxresult.h"
#include "hxcom.h"

class CHXKeepAliveImp;
_INTERFACE IHXScheduler;
_INTERFACE IHXCallback;

/*
 * CHXKeepAlive
 * This object implements basic keepalive functionallity. The object
 * is initialized with a IHXScheduler, a keepalive timeout, and a keepalive
 * callback. Anytime that activity occurs, OnActivity() should be called.
 * If a timeout interval goes by without receiving an OnActivity() call,
 * this object calls the keepalive callback passed in the Init() call.
 */

class CHXKeepAlive
{
public:
    CHXKeepAlive();
    ~CHXKeepAlive();
    
    HX_RESULT Init(IHXScheduler* pSched, 
		   UINT32 timeoutMS, 
		   IHXCallback* pKeepAliveCB);

    void OnActivity();  // Called when any activity has occured
    void reset();       // Clears the state of this object

private:
    CHXKeepAliveImp* m_pImp;
};

#endif /* CHXKEEPALIVE_H */
