/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: RCSL 1.0 
 *  
 * Portions Copyright (c) 1995-2002 RealNetworks, Inc. All Rights Reserved. 
 *  
 * The contents of this file, and the files included with this file, are 
 * subject to the current version of RealNetworks Community Source License 
 * Version 1.0 (the "License"). You may not use this file except in 
 * compliance with the License executed by both you and RealNetworks.  You 
 * may obtain a copy of the License at  
 * http://www.helixcommunity.org/content/rcsl.  You may also obtain a 
 * copy of the License by contacting RealNetworks directly.  Please see the 
 * License for the rights, obligations and limitations governing use of the 
 * contents of the file. 
 *  
 * This file is part of the Helix DNA Technology. RealNetworks is the 
 * developer of the Original Code and owns the copyrights in the portions 
 * it created. 
 *  
 * This file, and the files included with this file, is distributed and made 
 * available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS ALL SUCH WARRANTIES, 
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS 
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.  
 * 
 * Technology Compatibility Kit Test Suite(s) Location: 
 *    http://www.helixcommunity.org/content/tck 
 * 
 * Contributor(s): 
 *  
 * ***** END LICENSE BLOCK ***** */ 
//  $Id: errmsg_macros.h,v 1.1 2004/10/02 18:50:36 jyelon Exp $
#ifndef _ERRMSG_MACROS_H_
#define _ERRMSG_MACROS_H_

#include "hlxclib/stdio.h" /* for vsnprintf */
#include <stdlib.h>
#include <stdarg.h>
#include "atomicbase.h"
#include "hxcom.h"
#include "hxerror.h"



inline void
ERRMSG(IHXErrorMessages* messages, const char* fmt, ...)
{
    char buf[4096]; /* Flawfinder: ignore */
    va_list args;

    va_start(args, fmt);
    snprintf(buf, 4096, fmt, args);
    buf[4095] = '\0';

    if (messages)
    {
	messages->Report(HXLOG_ERR,
	                 HXR_FAIL,
	                 (ULONG32)HXR_FAIL,
	                 buf,
	                 0);
    }

    va_end(args);
}

/*
 * generic message logger.  See hxerror.h for severity values.
 */
inline void
LOGMSG(IHXErrorMessages* messages, const UINT8 severity, const char* fmt, ...)
{
    char buf[4096]; /* Flawfinder: ignore */
    va_list args;

    va_start(args, fmt);
    snprintf(buf, 4096, fmt, args);
    buf[4095] = '\0';

    if (messages)
    {
	messages->Report(severity,
	                 0,
	                 0,
	                 buf,
	                 0);
    }

    va_end(args);
}

#endif /* _ERRMSG_MACROS_H_ */
