/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: RCSL 1.0/RPSL 1.0 
 *  
 * Portions Copyright (c) 1995-2002 RealNetworks, Inc. All Rights Reserved. 
 *      
 * The contents of this file, and the files included with this file, are 
 * subject to the current version of the RealNetworks Public Source License 
 * Version 1.0 (the "RPSL") available at 
 * http://www.helixcommunity.org/content/rpsl unless you have licensed 
 * the file under the RealNetworks Community Source License Version 1.0 
 * (the "RCSL") available at http://www.helixcommunity.org/content/rcsl, 
 * in which case the RCSL will apply. You may also obtain the license terms 
 * directly from RealNetworks.  You may not use this file except in 
 * compliance with the RPSL or, if you have a valid RCSL with RealNetworks 
 * applicable to this file, the RCSL.  Please see the applicable RPSL or 
 * RCSL for the rights, obligations and limitations governing use of the 
 * contents of the file.  
 *  
 * This file is part of the Helix DNA Technology. RealNetworks is the 
 * developer of the Original Code and owns the copyrights in the portions 
 * it created. 
 *  
 * This file, and the files included with this file, is distributed and made 
 * available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS ALL SUCH WARRANTIES, 
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS 
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. 
 * 
 * Technology Compatibility Kit Test Suite(s) Location: 
 *    http://www.helixcommunity.org/content/tck 
 * 
 * Contributor(s): 
 *  
 * ***** END LICENSE BLOCK ***** */ 

#ifndef HLXSYS_ASSERT_H
#define HLXSYS_ASSERT_H

#if defined(_OPENWAVE)
#include "platform/openwave/hx_op_debug.h"
#define assert(x) OpASSERT(x)
#elif !defined(WIN32_PLATFORM_PSPC)
#include <assert.h>
#endif /* !defined(WIN32_PLATFORM_PSPC) */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


void __helix_assert(const char* pExpression, 
		    const char* pFilename, int lineNum);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#if defined(WIN32_PLATFORM_PSPC)

#include "hxtypes.h"
#include <winbase.h>
#include <dbgapi.h>

#ifdef _DEBUG
#define assert(x) if(!(x)) __helix_assert(#x, __FILE__, __LINE__);
#else /* _DEBUG */
#define assert(x)
#endif /* _DEBUG */

#endif /* defined(WIN32_PLATFORM_PSPC) */

#endif /* HLXSYS_ASSERT_H */
