/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: RCSL 1.0/RPSL 1.0 
 *  
 * Portions Copyright (c) 1995-2002 RealNetworks, Inc. All Rights Reserved. 
 *      
 * The contents of this file, and the files included with this file, are 
 * subject to the current version of the RealNetworks Public Source License 
 * Version 1.0 (the "RPSL") available at 
 * http://www.helixcommunity.org/content/rpsl unless you have licensed 
 * the file under the RealNetworks Community Source License Version 1.0 
 * (the "RCSL") available at http://www.helixcommunity.org/content/rcsl, 
 * in which case the RCSL will apply. You may also obtain the license terms 
 * directly from RealNetworks.  You may not use this file except in 
 * compliance with the RPSL or, if you have a valid RCSL with RealNetworks 
 * applicable to this file, the RCSL.  Please see the applicable RPSL or 
 * RCSL for the rights, obligations and limitations governing use of the 
 * contents of the file.  
 *  
 * This file is part of the Helix DNA Technology. RealNetworks is the 
 * developer of the Original Code and owns the copyrights in the portions 
 * it created. 
 *  
 * This file, and the files included with this file, is distributed and made 
 * available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS ALL SUCH WARRANTIES, 
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS 
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. 
 * 
 * Technology Compatibility Kit Test Suite(s) Location: 
 *    http://www.helixcommunity.org/content/tck 
 * 
 * Contributor(s): 
 *  
 * ***** END LICENSE BLOCK ***** */ 

#ifndef _HXCBOBJ_H_
#define _HXCBOBJ_H_

#include "hxengin.h"

typedef void (*fGenericCBFunc)(void* pParam);

class CHXGenericCallback : public IHXCallback
{
public:
    CHXGenericCallback(void* pParam, fGenericCBFunc pFunc);
    virtual ~CHXGenericCallback();

    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObj);
    STDMETHOD_(ULONG32,AddRef)	(THIS);
    STDMETHOD_(ULONG32,Release)	(THIS);

    STDMETHOD(Func)(THIS);

    void            CallbackScheduled(CallbackHandle hHandle) {m_PendingHandle = hHandle;}
    void            CallbackCanceled()   {m_PendingHandle = 0;}
    CallbackHandle  GetPendingCallback() {return m_PendingHandle;}
    BOOL            IsCallbackPending()  { return (m_PendingHandle ? TRUE : FALSE); }

    // Helper functions for commonly-used tasks
    void ScheduleRelative(IHXScheduler* pScheduler, UINT32 ulMs);
    void Cancel(IHXScheduler* pScheduler);

protected:

    LONG32          m_lRefCount;
    fGenericCBFunc  m_fpCB;
    void*           m_pParam;
    CallbackHandle  m_PendingHandle;
};

#endif //_HXCBOBJ_H_
